#Copyright (C) 2018 ThinkPenguin, Inc
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#!/bin/sh

PATH=$PATH:/bin:/sbin:/usr/sbin


#don't continue if the distribution is not Ubuntu
if [ "`grep ubuntu /etc/os-release > /dev/null;echo $?`" != "0"  ]
then
	exit;
fi

#set the variable v to indicate the version of Ubuntu being used		
v=`grep VERSION_ID /etc/os-release |   cut -d'"' -f2`

#set variable bit to tell script if this is a 32 or 64 bit system
if [ "`uname -m`" != "x86_64" ]
then
   bit="32"
else
   bit="64"
fi

pwd=`pwd`/

#set the variable x to the packages which need to be installed for this version of Ubuntu
case "$v" in  
12.04|12.10|13.04|13.10|13|14|15|16) x=`ls $pwd$bit.1204/*.deb | xargs`
   ;;
14.04|14.10|15.04|15.10|17|17.1|17.2|17.3) x=`ls $pwd$bit.1404/*.deb | xargs`
   ;;
16.04|16.10|17.04|17.10|18|18.1|18.2|18.3) x=`ls $pwd$bit.1604/*.deb | xargs`
   ;;
18.04|18.10|19.04|19.10|19|19.1|19.2|19.3) x=`ls $pwd$bit.1804/*.deb | xargs`
   ;;
*) 	zenity --error --text "It appears this version of Ubuntu is not supported" ;
exit;; 
esac


#install the packages
pkexec dpkg -i $x | zenity --progress --text "Please wait while we install the needed packages for your system" --pulsate



#for all recent versions of Ubuntu

#add all the normal users to the dial-out group
awk -F: '$3 > 999 {print $1}' /etc/passwd | xargs -I USERNAME pkexec adduser USERNAME dialout

#ask user to connect modem
while [ ! -c /dev/ttyACM0 ];do echo not detected yet; sleep 2 ;done | zenity --progress --text "Detecting modem: please plug in now" --pulsate

#create symbolic link from /dev/modem to /dev/ttyACM0
pkexec ln -s /dev/ttyACM0 /dev/modem

#create gnome-ppp link on current logged in desktop
cp /usr/share/applications/gnome-ppp.desktop  ~/Desktop
cp /usr/share/applications/efax-gtk.desktop ~/Desktop
chmod a+x ~/Desktop/gnome-ppp.desktop  
chmod a+x ~/Desktop/efax-gtk.desktop 

#have user reboot to finish the setup
zenity --info --text "To finish the setup you need to reboot the computer: Then run GNOME-PPP, click the Setup button, Detect button, and enter a user name, password, and phone number for your ISP." --title "Installation Complete";


